#include <gnome.h>
#include "draw.h"
#include "statusbar.h"
#include "levels.h"
#include "options.h"
#include "vroom.h"
#include <gtk/gtk.h>

struct _level;
extern statusbar;
int it_cntr;

GnomeCanvasItem** it_arr;
int hprog=0;


void show_helpers(struct _level *cl,int gx,int gy)
{
	extern struct _vroom *_curroom;
	extern int isrx;
	extern int isry;
	
	int x,y;
	int rs,rs1;
	int i;

	rs=(int)RSIZE2;
	rs1=RSIZE2;
	x=gx*rs+rs1;
	y=gy*rs+rs1;
	
	
	if (hprog==2) return;
	hprog=2;
	it_arr=malloc(sizeof(GnomeCanvasItem*)*8);
	
	for (i=0; i<8; i++) it_arr[i]=0;	
	
	
	if ((gx % 2 == isrx) && ((gy-1) % 2==isry))
	it_arr[0]=draw_preview(cl->group,x,y-RSIZE2);

	if ((gx % 2 == isrx) && ((gy+1) % 2==isry))
	it_arr[1]=draw_preview(cl->group,x,y+RSIZE2);
	
	if (((gx+1) % 2 == isrx) && ((gy) % 2==isry))
	it_arr[2]=draw_preview(cl->group,x+RSIZE2,y);
	
	if (((gx-1) % 2 == isrx) && ((gy) % 2==isry))
	it_arr[3]=draw_preview(cl->group,x-RSIZE2,y);
	
	if (((gx-1) % 2 == isrx) && ((gy-1) % 2==isry))
	it_arr[4]=draw_preview(cl->group,x-RSIZE2,y-RSIZE2);

	if (((gx-1) % 2 == isrx) && ((gy+1) % 2==isry))
	it_arr[5]=draw_preview(cl->group,x-RSIZE2,y+RSIZE2)
;
	if (((gx+1) % 2 == isrx) && ((gy-1) % 2==isry))
	it_arr[6]=draw_preview(cl->group,x+RSIZE2,y-RSIZE2);

	if (((gx+1) % 2 == isrx) && ((gy+1) % 2==isry))
	it_arr[7]=draw_preview(cl->group,x+RSIZE2,y+RSIZE2);
}

gboolean hide_helpers(gpointer data)
{
	int i;
	GtkObject *ob;
	extern int helpers_tag;

	if (hprog!=2) return;	

	for (i=0; i<8; i++)
	{
		ob=(GtkObject*)(it_arr[i]);
		
		if (ob) gtk_object_destroy(ob);
	}

	gtk_timeout_remove(helpers_tag);
	free(it_arr);
	hprog=1;
}

int status_msg(char *text)
{
	gtk_statusbar_pop((GtkStatusbar*)statusbar,0);
	gtk_statusbar_push((GtkStatusbar*)statusbar,0,text);
}

int mdialog_msg(char *text)
{
	GtkWidget *dialog, *label, *bt;
	int button;
	GtkWidget  *dbox;
	GtkWidget *daa;
	
	dialog=gnome_message_box_new(_(text),
		GNOME_MESSAGE_BOX_ERROR,NULL);
	gtk_container_set_border_width(GTK_CONTAINER(dialog),4);
	gtk_window_set_modal(GTK_WINDOW(dialog),TRUE);
	gtk_window_set_title(GTK_WINDOW(dialog),_("Error"));
	gtk_window_set_resizable(GTK_WINDOW(dialog),FALSE);
	gtk_window_set_destroy_with_parent(GTK_WINDOW(dialog),TRUE);

	dbox=GNOME_DIALOG(dialog)->vbox;
	gtk_widget_show(dbox);
	daa=GNOME_DIALOG(dialog)->action_area;
	gtk_widget_show(daa);
	gtk_button_box_set_layout(GTK_BUTTON_BOX(daa),
	GTK_BUTTONBOX_END);

	gnome_dialog_append_button(GNOME_DIALOG(dialog),"gtk-ok");
	bt=GTK_WIDGET(g_list_last(GNOME_DIALOG(dialog)->buttons)->data);
	gtk_widget_show(bt);
	GTK_WIDGET_SET_FLAGS(bt,GTK_CAN_DEFAULT);

	gtk_widget_show(dialog);	
}
